%global dlrn_nvr metalsmith-0.5.0-0.20180820154808.e2085dc
%global dlrn 1
%define upstream_version 0.5.0
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%if 0%{?fedora}
%global with_python3 1
%endif

%global with_doc 0
%global sname metalsmith

%global common_summary Bare metal provisioner using Ironic
%global common_desc Simple Python library and CLI tool to provision bare metal machines using OpenStack Ironic.
%global common_desc_tests Tests for metalsmith.

Name: python-%{sname}
Version: 0.5.0
Release: 0.20180820154808.e2085dc%{?dist}
Summary: %{common_summary}
License: ASL 2.0
URL: https://metalsmith.readthedocs.io/

Source0: metalsmith-0.5.0-0.20180820154808.e2085dc-e2085dc02669b9e25510edba7b4014b007af4ca5.tar.gz

BuildArch: noarch

%description
%{common_desc}

%package -n python2-%{sname}
Summary: %{common_summary}
%{?python_provide:%python_provide python2-%{sname}}

BuildRequires: git
BuildRequires: openstack-macros
BuildRequires: python2-devel
BuildRequires: python2-pbr
BuildRequires: python2-setuptools
# Required for running unit tests
BuildRequires: python2-ironicclient
BuildRequires: python2-mock
BuildRequires: python2-openstacksdk
BuildRequires: python2-six
BuildRequires: python2-testtools

Requires: python2-ironicclient >= 1.14.0
Requires: python2-openstacksdk >= 0.11.0
Requires: python2-pbr >= 2.0.0
Requires: python2-six >= 1.10.0

Requires(pre): shadow-utils

%description -n python2-%{sname}
%{common_desc}

%package -n python2-%{sname}-tests
Summary: metalsmith tests
Requires: python2-%{sname} = %{version}-%{release}
Requires: python2-mock
Requires: python2-testtools

%description -n python2-%{sname}-tests
%{common_desc_tests}

%if 0%{?with_python3}

%package -n python3-%{sname}
Summary: %{common_summary}

%{?python_provide:%python_provide python3-%{sname}}
BuildRequires: python3-devel
BuildRequires: python3-pbr
BuildRequires: python3-setuptools
# Required for running unit tests
BuildRequires: python3-ironicclient
BuildRequires: python3-mock
BuildRequires: python3-openstacksdk
BuildRequires: python3-six
BuildRequires: python3-testtools

Requires: python3-ironicclient >= 1.14.0
Requires: python3-openstacksdk >= 0.11.0
Requires: python3-pbr >= 2.0.0
Requires: python3-six >= 1.10.0

%description -n python3-%{sname}
%{common_desc}

%package -n python3-%{sname}-tests
Summary: metalsmith tests
Requires: python3-%{sname} = %{version}-%{release}
Requires: python3-mock
Requires: python3-testtools

%description -n python3-%{sname}-tests
%{common_desc_tests}

%endif # with_python3

%if 0%{?with_doc}
%package -n python-%{sname}-doc
Summary: %{common_summary} - documentation

BuildRequires: python2-sphinx
BuildRequires: python2-sphinxcontrib-apidoc

%description -n python-%{sname}-doc
%{common_summary}

This package contains documentation.
%endif

%package -n ansible-role-%{sname}-deployment
Summary: %{common_summary} - ansible role

# The ansible role uses CLI which is currently provided by the Python 2
# package. Change this when the CLI is provided by the Python 3 package.
Requires: python2-%{sname} = %{version}-%{release}
Requires: ansible >= 2.3

%description -n ansible-role-%{sname}-deployment
%{common_summary}

This package contains the metalsmith_deployment role to use metalsmith
in ansible playbooks.

%prep
%autosetup -n %{sname}-%{upstream_version} -S git

# Let's handle dependencies ourseleves
%py_req_cleanup

%build
%py2_build
%if 0%{?with_python3}
%py3_build
%endif # with_python3

%if 0%{?with_doc}
# generate html docs
sphinx-build -b html doc/source doc/build/html
# remove the sphinx-build leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

%install
%if 0%{?with_python3}
%py3_install
# Follow Python guidelines around Python CLI versioning
pushd %{buildroot}/%{_bindir}
mv metalsmith{,-%{python3_version}}
ln -s metalsmith{-%{python3_version},-3}
popd
%endif # with_python3

%py2_install
# Follow Python guidelines around Python CLI versioning
pushd %{buildroot}/%{_bindir}
mv metalsmith{,-2.7}
ln -s metalsmith{-2.7,-2}
# This is the final binary that actual humans will be using
ln -s metalsmith{-2,}
popd

%check
%{__python2} -m unittest discover metalsmith.test

%if 0%{?with_python3}
%{__python3} -m unittest discover metalsmith.test
%endif # with_python3

%files -n python2-%{sname}
%license LICENSE
%{_bindir}/metalsmith
%{_bindir}/metalsmith-2
%{_bindir}/metalsmith-2.7
%{python2_sitelib}/%{sname}
%{python2_sitelib}/%{sname}-*.egg-info
%exclude %{python2_sitelib}/%{sname}/test

%files -n python2-%{sname}-tests
%license LICENSE
%{python2_sitelib}/%{sname}/test

%if 0%{?with_python3}

%files -n python3-%{sname}
%license LICENSE
%{_bindir}/metalsmith-3
%{_bindir}/metalsmith-%{python3_version}
%{python3_sitelib}/%{sname}
%{python3_sitelib}/%{sname}-*.egg-info
%exclude %{python3_sitelib}/%{sname}/test

%files -n python3-%{sname}-tests
%license LICENSE
%{python3_sitelib}/%{sname}/test

%endif # with_python3

%if 0%{?with_doc}
%files -n python-%{sname}-doc
%license LICENSE
%doc doc/build/html README.rst
%endif

%files -n ansible-role-%{sname}-deployment
%license LICENSE
%doc roles/metalsmith_deployment/README.rst
%{_datadir}/ansible/roles/metalsmith_deployment
%exclude %{_datadir}/ansible/roles/metalsmith_deployment/README.rst

%changelog
